/*
   edu.cpp knihovna na ovládání Edushield
   Vytvořil Kryštof Keil 24.června 2017
*/

#include "Arduino.h"
#include "Edu.h"

#define colorRedRed 255
#define colorRedGreen 0
#define colorRedBlue 0

#define colorGreenRed 0
#define colorGreenGreen 255
#define colorGreenBlue 0

#define colorBlueRed 0
#define colorBlueGreen 0
#define colorBlueBlue 255

#define colorYellowRed 255
#define colorYellowGreen 255
#define colorYellowBlue 0

#define colorMagentaRed 255
#define colorMagentaGreen 0
#define colorMagentaBlue 255

#define colorCyanRed 0
#define colorCyanGreen 255
#define colorCyanBlue 255

#define colorWhiteRed 255
#define colorWhiteGreen 255
#define colorWhiteBlue 255

#define colorDarkRed 0
#define colorDarkGreen 0
#define colorDarkBlue 0

Edu::Edu(int a)
{
  pinMode(A2, OUTPUT); //cervena dioda na Edushield
  pinMode(A3, OUTPUT); //oranzova
  pinMode(13, OUTPUT); //zluta
  pinMode(9, OUTPUT); //cervena na RGB
  pinMode(5, OUTPUT); //zelena na RGB
  pinMode(6, OUTPUT); //modra na RGB
}

void Edu::Red(boolean stateR)
{
  digitalWrite(A2, stateR);
}

void Edu::Ora(boolean stateO)
{
  digitalWrite(A3, stateO);
}

void Edu::Yel(boolean stateY)
{
  digitalWrite(13, stateY);
}

void Edu::R(byte shineR)
{
  analogWrite(9, 255 - shineR); //ovladame PWM, ale LED sviti pokud je v LOW, proto 255-shineR
}
void Edu::G(byte shineG)
{
  analogWrite(5, 255 - shineG);
}
void Edu::B(byte shineB)
{
  analogWrite(6, 255 - shineB);
}
void Edu::RGB(char color)
{
  switch (color) {
    case 'R': analogWrite(9, 255-colorRedRed); analogWrite(5, 255-colorRedGreen); analogWrite(6, 255-colorRedBlue); break;
    case 'G': analogWrite(9, 255 - colorGreenRed); analogWrite(5, 255 - colorGreenGreen); analogWrite(6, 255 - colorGreenBlue); break;
    case 'B': analogWrite(9, 255 - colorBlueRed); analogWrite(5, 255 - colorBlueGreen); analogWrite(6, 255 - colorBlueBlue); break;
    case 'Y': analogWrite(9, 255 - colorYellowRed); analogWrite(5, 255 - colorYellowGreen); analogWrite(6, 255 - colorYellowBlue); break;
    case 'M': analogWrite(9, 255 - colorMagentaRed); analogWrite(5, 255 - colorMagentaGreen); analogWrite(6, 255 - colorMagentaBlue); break;
    case 'C': analogWrite(9, 255 - colorCyanRed); analogWrite(5, 255 - colorCyanGreen); analogWrite(6, 255 - colorCyanBlue); break;
    case 'W': analogWrite(9, 255 - colorWhiteRed); analogWrite(5, 255 - colorWhiteGreen); analogWrite(6, 255 - colorWhiteBlue); break;
    case 'D': analogWrite(9, 255 - colorDarkRed); analogWrite(5, 255 - colorDarkGreen); analogWrite(6, 255 - colorDarkBlue); break;
  }
}
void Edu::RGBcustom(byte R, byte G, byte B)
{
  analogWrite(9, 255 - R); analogWrite(5, 255 - G); analogWrite(6, 255 - B);
}

